'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _redboxReact2 = require('redbox-react');

var _redboxReact3 = _interopRequireDefault(_redboxReact2);

var _react2 = require('react');

var _react3 = _interopRequireDefault(_react2);

var _reactTransformCatchErrors3 = require('react-transform-catch-errors');

var _reactTransformCatchErrors4 = _interopRequireDefault(_reactTransformCatchErrors3);

var _class, _temp;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _server = require('react-dom/server');

var _server2 = _interopRequireDefault(_server);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _Body = require('./Body');

var _Body2 = _interopRequireDefault(_Body);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _components = {
  Html: {
    displayName: 'Html'
  }
};

var _reactTransformCatchErrors2 = (0, _reactTransformCatchErrors4.default)({
  filename: 'src/Html.js',
  components: _components,
  locals: [],
  imports: [_react3.default, _redboxReact3.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformCatchErrors2(Component, id);
  };
}

/**
 * Wrapper component containing HTML metadata and boilerplate tags.
 * Used in server-side code only to wrap the string output of the
 * rendered route component.
 *
 * The only thing this component doesn't (and can't) include is the
 * HTML doctype declaration, which is added to the rendered output
 * by the server.js file.
 */
var Html = _wrapComponent('Html')((_temp = _class = function (_Component) {
  (0, _inherits3.default)(Html, _Component);

  function Html() {
    (0, _classCallCheck3.default)(this, Html);
    return (0, _possibleConstructorReturn3.default)(this, (Html.__proto__ || (0, _getPrototypeOf2.default)(Html)).apply(this, arguments));
  }

  (0, _createClass3.default)(Html, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          assets = _props.assets,
          component = _props.component,
          store = _props.store,
          statics = _props.statics,
          fetcher = _props.fetcher,
          _props$enableScript = _props.enableScript,
          enableScript = _props$enableScript === undefined ? true : _props$enableScript;

      var content = component ? _server2.default.renderToString(component) : '';
      var head = _reactHelmet2.default.rewind();

      return _react3.default.createElement(
        'html',
        { lang: 'en-us' },
        _react3.default.createElement(
          'head',
          null,
          _react3.default.createElement('meta', { name: 'viewport', content: 'width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, user-scalable=no' }),
          _react3.default.createElement('meta', { name: 'apple-mobile-web-app-capable', content: 'yes' }),
          _react3.default.createElement('script', { src: '/koiki-sw-register.js' }),
          _react3.default.createElement('link', { rel: 'manifest', href: '/manifest.json' }),
          _react3.default.createElement('link', { rel: 'shortcut icon', href: '/images/favicon.png' }),
          _react3.default.createElement('link', { rel: 'apple-touch-icon', href: '/images/favicon.png' }),
          (0, _keys2.default)(assets.styles).map(function (style, key) {
            return _react3.default.createElement('link', { href: assets.styles[style], key: key, media: 'screen, projection',
              rel: 'stylesheet', type: 'text/css', charSet: 'UTF-8' });
          }),
          (0, _keys2.default)(statics || {}).map(function (tag) {
            return tag === 'link' ? statics[tag].map(function (attributes) {
              return _react3.default.createElement('link', (0, _extends3.default)({ key: attributes.rel + '-' + attributes.href }, attributes));
            }) : tag === 'script' && enableScript ? statics[tag].map(function (attributes) {
              return _react3.default.createElement('script', (0, _extends3.default)({ key: attributes.src }, attributes));
            }) : '';
          }),
          head.base.toComponent(),
          head.title.toComponent(),
          head.meta.toComponent(),
          head.link.toComponent(),
          enableScript ? head.script.toComponent() : null
        ),
        _react3.default.createElement(_Body2.default, { assets: assets, content: content, store: store, fetcher: fetcher, enableScript: enableScript })
      );
    }
  }]);
  return Html;
}(_react2.Component), _class.propTypes = {
  assets: _propTypes2.default.object,
  component: _propTypes2.default.node,
  store: _propTypes2.default.object,
  statics: _propTypes2.default.object,
  fetcher: _propTypes2.default.object,
  enableScript: _propTypes2.default.bool
}, _temp));

exports.default = Html;
module.exports = exports['default'];