'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Offline = function Offline(props) {
  return _react2.default.createElement(
    'div',
    {
      style: {
        backgroundColor: props.colors.background || 'transparent'
      },
      className: 'root'
    },
    _react2.default.createElement('link', { rel: 'stylesheet', type: 'text/css', href: '/css/offline.css' }),
    _react2.default.createElement('script', { src: '/pulltorefresh.min.js' }),
    _react2.default.createElement('script', { src: '/pulltorefresh-init.js' }),
    _react2.default.createElement(
      'div',
      { className: 'container' },
      _react2.default.createElement(
        'div',
        { className: 'logo' },
        _react2.default.createElement('img', {
          alt: 'chaus',
          className: 'img',
          src: '/images/favicon.png'
        })
      ),
      _react2.default.createElement(
        'div',
        { className: 'message', style: { color: props.colors.primary } },
        'Network Connection Failed'
      ),
      _react2.default.createElement(
        'div',
        { className: 'button' },
        _react2.default.createElement(
          'a',
          {
            style: {
              backgroundColor: props.colors.primary,
              color: props.colors.secondary
            },
            className: 'reload',
            href: ''
          },
          'Reload'
        ),
        _react2.default.createElement(
          'div',
          {
            style: { color: props.colors.primary },
            className: 'pull-to-refresh',
            href: ''
          },
          'Pull down to refresh'
        )
      )
    )
  );
};

Offline.propTypes = {
  colors: _propTypes2.default.shape({
    background: _propTypes2.default.string,
    primary: _propTypes2.default.string,
    secondary: _propTypes2.default.string
  })
};

Offline.defaultProps = {
  colors: {}
};

exports.default = Offline;
module.exports = exports['default'];