'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var get = function get(url, cookie) {
  return fetch('' + url, {
    credentials: 'include',
    headers: {
      cookie: 'connect.sid=' + cookie.get('connect.sid')
    }
  }).then(function (res) {
    if (res.ok) {
      return res.json();
    }
    return (0, _promise2.default)(function (resolve, reject) {
      return reject('User does not logged in yet');
    });
  });
};

var check = function check(store, cookie) {
  var origin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'http://localhost:3000';
  var setUser = arguments[3];

  return function (nextState, replace, cb) {
    var isLogin = store.getState().user && store.getState().user.item && store.getState().user.item.id;
    if (isLogin) {
      cb();
    } else {
      get(origin + '/auth', cookie).then(
      // login user
      function (res) {
        store.dispatch(setUser({
          id: res.id,
          token: res.token
        }));
        cb();
      }, function () {
        cb();
      });
    }
  };
};

var login = function login(store, cookie) {
  var origin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'http://localhost:3000';
  var authenticator = arguments[3];
  var setUser = arguments[4];

  var connectedCheck = check(store, cookie, origin, setUser);
  return function (nextState, replace, cb) {
    connectedCheck(nextState, replace, function () {
      var isLogin = store.getState().user && store.getState().user.item && store.getState().user.item.id;
      if (isLogin) {
        cb();
      } else {
        cookie.set('redirect', nextState.location.pathname, {
          path: '/'
        });
        if (__SERVER__) {
          replace('/auth/' + authenticator);
          cb();
        } else {
          location.href = origin + '/auth/' + authenticator;
        }
      }
    });
  };
};

exports.default = {
  check: check,
  login: login
};
module.exports = exports['default'];