'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = client;

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactRouter = require('react-router');

var _createBrowserHistory = require('history/lib/createBrowserHistory');

var _createBrowserHistory2 = _interopRequireDefault(_createBrowserHistory);

var _useStandardScroll = require('scroll-behavior/lib/useStandardScroll');

var _useStandardScroll2 = _interopRequireDefault(_useStandardScroll);

var _create = require('./create');

var _create2 = _interopRequireDefault(_create);

var _apiclient = require('./apiclient');

var _apiclient2 = _interopRequireDefault(_apiclient);

var _reactRedux = require('react-redux');

var _reduxConnect = require('redux-connect');

var _fetcher = require('./fetcher');

var _fetcher2 = _interopRequireDefault(_fetcher);

var _App = require('./App');

var _App2 = _interopRequireDefault(_App);

var _cookieDough = require('cookie-dough');

var _cookieDough2 = _interopRequireDefault(_cookieDough);

var _createRouterOpts = require('./createRouterOpts');

var _createRouterOpts2 = _interopRequireDefault(_createRouterOpts);

var _ws = require('./ws');

var _ws2 = _interopRequireDefault(_ws);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function client(_ref) {
  var urls = _ref.urls,
      reducers = _ref.reducers,
      routes = _ref.routes,
      _ref$dest = _ref.dest,
      dest = _ref$dest === undefined ? document.getElementById('content') : _ref$dest,
      _ref$isDevelopment = _ref.isDevelopment,
      isDevelopment = _ref$isDevelopment === undefined ? false : _ref$isDevelopment,
      wsUrl = _ref.wsUrl;

  var createScrollHistory = (0, _useStandardScroll2.default)(_createBrowserHistory2.default);

  var history = (0, _reactRouter.useRouterHistory)(createScrollHistory)((0, _createRouterOpts2.default)({
    shouldUpdateScroll: function shouldUpdateScroll(oldLocation, newLocation) {
      return (
        // Don't scroll if the pathname is the same
        oldLocation ? newLocation.pathname !== oldLocation.pathname : newLocation.pathname !== location.pathname
      );
    }
  }));

  var store = (0, _create2.default)({ reducers: reducers, history: history, data: window.__data, isDevelopment: isDevelopment });
  var fetcher = new _fetcher2.default({
    dispatch: store.dispatch,
    client: new _apiclient2.default(),
    urls: urls,
    serialized: window.__fetcher,
    type: 'client'
  });
  if (wsUrl) {
    (0, _ws2.default)({
      dispatch: store.dispatch,
      urls: urls,
      wsUrl: wsUrl
    });
  }
  var cookie = (0, _cookieDough2.default)();

  var component = _react2.default.createElement(
    _reactRouter.Router,
    {
      render: function render(props) {
        return _react2.default.createElement(_reduxConnect.ReduxAsyncConnect, (0, _extends3.default)({}, props, { cookie: cookie, helpers: { fetcher: fetcher }, filter: function filter(item) {
            return !item.deferred;
          } }));
      },
      history: history
    },
    _react2.default.createElement(
      _reactRouter.Route,
      {
        component: _App2.default,
        urls: urls,
        cookie: cookie,
        fetcher: fetcher
      },
      routes(store, cookie)
    )
  );

  _reactDom2.default.render(_react2.default.createElement(
    _reactRedux.Provider,
    { store: store, key: 'provider' },
    component
  ), dest);

  if (process.env.NODE_ENV !== 'production') {
    window.React = _react2.default; // enable debugger
    if (!dest || !dest.firstChild || !dest.firstChild.attributes || !dest.firstChild.attributes['data-react-checksum']) {
      console.error('Server-side React render was discarded. Make sure that your initial render does not contain any client-side code.');
    }
  }
} /**
   * THIS IS THE ENTRY POINT FOR THE CLIENT, JUST LIKE server.js IS THE ENTRY POINT FOR THE SERVER.
   */
module.exports = exports['default'];