'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createStore;

var _redux = require('redux');

var _reactRouterRedux = require('react-router-redux');

function createStore(_ref) {
  var reducers = _ref.reducers,
      history = _ref.history,
      data = _ref.data,
      isDevelopment = _ref.isDevelopment;

  // Sync dispatched route actions to the history
  var reduxRouterMiddleware = (0, _reactRouterRedux.routerMiddleware)(history);

  var middleware = [reduxRouterMiddleware];

  var finalCreateStore = void 0;
  finalCreateStore = _redux.applyMiddleware.apply(undefined, middleware)(_redux.createStore);

  var reducer = require('./reducer')(reducers, isDevelopment);
  var store = finalCreateStore(reducer, data);

  return store;
}
module.exports = exports['default'];