'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _qs = require('qs');

var _urlPluck = require('./url-pluck');

var _urlPluck2 = _interopRequireDefault(_urlPluck);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var exec = function exec(_ref) {
  var dispatch = _ref.dispatch,
      client = _ref.client,
      url = _ref.url,
      method = _ref.method,
      values = _ref.values,
      start = _ref.start,
      success = _ref.success,
      fail = _ref.fail,
      mode = _ref.mode,
      credentials = _ref.credentials,
      headers = _ref.headers,
      _ref$after = _ref.after,
      after = _ref$after === undefined ? function (_values, res) {
    return new _promise2.default(function (resolve) {
      return resolve(res.body);
    });
  } : _ref$after,
      next = _ref.next,
      cache = _ref.cache,
      useQuery = _ref.useQuery;

  dispatch(start(fetch.values));
  return client.fetchJSON({
    url: url,
    method: method,
    values: values,
    mode: mode,
    credentials: credentials,
    headers: headers,
    cache: cache,
    useQuery: useQuery
  }).then(function (res) {
    return after(values, res).then(function (converted) {
      dispatch(success({
        body: converted,
        res: res,
        next: next ? next(converted) : ''
      }));
      return _promise2.default.resolve({
        body: converted,
        res: res.res
      });
    });
  }, function (res) {
    dispatch(fail(res));
    return _promise2.default.reject({
      body: res.body,
      res: res.res
    });
  });
};

var getExecOptions = function getExecOptions(applyWith, _ref2) {
  var options = _ref2.options,
      values = _ref2.values,
      urls = _ref2.urls,
      dispatch = _ref2.dispatch,
      client = _ref2.client,
      resource = _ref2.resource,
      action = _ref2.action,
      type = _ref2.type;
  return {
    dispatch: dispatch,
    client: client,
    url: urls[resource][action].url,
    method: urls[resource][action].method,
    after: urls[resource][action].after,
    next: urls[resource][action].next,
    cache: urls[resource][action].cache && urls[resource][action].cache[type],
    mode: options.mode !== undefined ? options.mode : urls[resource][action].mode,
    credentials: options.credentials !== undefined ? options.credentials : urls[resource][action].credentials,
    headers: options.headers !== undefined ? options.headers : urls[resource][action].headers,
    useQuery: options.useQuery !== undefined ? options.useQuery : urls[resource][action].useQuery,
    values: values,
    start: function start() {
      return {
        values: values,
        type: resource + '/' + action.toUpperCase() + '_START'
      };
    },
    success: function success(_ref3) {
      var body = _ref3.body,
          res = _ref3.res,
          next = _ref3.next;

      applyWith[resource][action].nextUrl = next;
      applyWith[resource][action].next = function () {
        return generateNext(applyWith, { // eslint-disable-line no-use-before-define
          action: action,
          options: options,
          resource: resource,
          urls: urls,
          next: next,
          dispatch: dispatch,
          client: client
        });
      };
      return {
        values: values,
        body: body,
        res: res,
        type: resource + '/' + action.toUpperCase() + '_SUCCESS',
        hasNext: urls[resource][action].next && next ? true : false
      };
    },
    fail: function fail(_ref4) {
      var body = _ref4.body,
          res = _ref4.res,
          err = _ref4.err;
      return {
        values: values,
        body: body,
        res: res,
        err: err,
        type: resource + '/' + action.toUpperCase() + '_FAIL'
      };
    }
  };
};

var generateNext = function generateNext(applyWith, _ref5) {
  var action = _ref5.action,
      options = _ref5.options,
      resource = _ref5.resource,
      urls = _ref5.urls,
      next = _ref5.next,
      dispatch = _ref5.dispatch,
      client = _ref5.client;


  if (!next) {
    return _promise2.default.resolve();
  }
  var values = (0, _qs.parse)((0, _urlPluck2.default)(next, ['query']));
  return exec((0, _extends3.default)({}, getExecOptions(applyWith, { options: options, urls: urls, dispatch: dispatch, client: client, resource: resource, action: action }), {
    start: function start() {
      return {
        values: values,
        type: resource + '/' + action.toUpperCase() + '_NEXT_START'
      };
    },
    success: function success(_ref6) {
      var body = _ref6.body,
          res = _ref6.res,
          _next = _ref6.next;

      applyWith[resource][action].nextUrl = _next;
      applyWith[resource][action].next = function () {
        return generateNext(applyWith, {
          action: action,
          options: options,
          resource: resource,
          urls: urls,
          next: _next,
          dispatch: dispatch,
          client: client
        });
      };
      return {
        values: values,
        body: body,
        res: res,
        type: resource + '/' + action.toUpperCase() + '_NEXT_SUCCESS',
        hasNext: urls[resource][action].next && _next ? true : false
      };
    },
    fail: function fail(_ref7) {
      var body = _ref7.body,
          res = _ref7.res,
          err = _ref7.err;
      return {
        values: values,
        body: body,
        res: res,
        err: err,
        type: resource + '/' + action.toUpperCase() + '_NEXT_FAIL'
      };
    },
    values: values,
    url: (0, _urlPluck2.default)(next, ['protocol', 'auth', 'host', 'pathname'])
  }));
};

var deserialize = function deserialize(applyWith, _ref8) {
  var serialized = _ref8.serialized,
      resource = _ref8.resource,
      action = _ref8.action,
      urls = _ref8.urls,
      dispatch = _ref8.dispatch,
      client = _ref8.client;

  if (serialized && serialized[resource] && serialized[resource][action] && serialized[resource][action].nextUrl) {
    applyWith[resource][action].next = function () {
      return generateNext(applyWith, {
        action: action,
        options: serialized[resource][action].options,
        resource: resource,
        urls: urls,
        next: serialized[resource][action].nextUrl,
        dispatch: dispatch,
        client: client
      });
    };
  } else {
    applyWith[resource][action].next = function () {
      return _promise2.default.resolve();
    };
  }
};

var fetcher = function () {
  function fetcher(_ref9) {
    var _this = this;

    var urls = _ref9.urls,
        dispatch = _ref9.dispatch,
        client = _ref9.client,
        serialized = _ref9.serialized,
        type = _ref9.type;
    (0, _classCallCheck3.default)(this, fetcher);


    (0, _keys2.default)(urls).map(function (resource) {
      _this[resource] = {};

      (0, _keys2.default)(urls[resource]).map(function (action) {
        _this[resource][action] = function (_values) {
          var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

          var values = (0, _assign2.default)({}, urls[resource][action].defaults || {}, _values);
          var execOptions = getExecOptions(_this, { options: options, values: values, urls: urls, dispatch: dispatch, client: client, resource: resource, action: action, type: type });
          _this[resource][action].options = options;
          var promise = exec(execOptions);
          return promise;
        };
        deserialize(_this, { serialized: serialized, resource: resource, action: action, urls: urls, dispatch: dispatch, client: client });
      });
    });
  }

  (0, _createClass3.default)(fetcher, [{
    key: 'get',
    value: function get(urls) {
      var _this2 = this;

      var serialized = {};
      (0, _keys2.default)(urls).map(function (resource) {
        serialized[resource] = {};
        (0, _keys2.default)(urls[resource]).map(function (action) {
          serialized[resource][action] = {
            nextUrl: _this2[resource][action].nextUrl,
            options: _this2[resource][action].options
          };
        });
      });
      return serialized;
    }
  }]);
  return fetcher;
}();

exports.default = fetcher;
module.exports = exports['default'];