'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = function (_ref) {
  var dispatch = _ref.dispatch,
      wsUrl = _ref.wsUrl,
      urls = _ref.urls;

  var WebSocket = window.WebSocket || window.MozWebsocket;
  if (!WebSocket) {
    console.log('WebSocket is not defined');
    return null;
  }
  var ws = new WebSocket(wsUrl);
  var remap = [];
  (0, _keys2.default)(urls).forEach(function (resource) {
    (0, _keys2.default)(urls[resource]).forEach(function (func) {
      if (urls[resource][func].ws) {
        remap.push({
          matcher: (0, _pathToRegexp2.default)(urls[resource][func].ws),
          resource: resource,
          func: func,
          method: urls[resource][func].method
        });
      }
    });
  });

  ws.onopen = function () {
    console.log('connected!');
    ws.onmessage = function (msg) {
      var json = JSON.parse(msg);
      remap.forEach(function (item) {
        var params = item.matcher.exec(json.uri);
        console.log(params);
        if (params && item.method === json.method) {
          dispatch({
            type: item.resource.toUpperCase() + '_' + item.func.toUpperCase(),
            data: json.data
          });
        }
      });
    };
  };

  ws.onclose = function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    console.log(args);
  };
  return ws;
};

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];